﻿using ProjectMotorboat.Drownings;
using ProjectMotorboat.Exceptions;

namespace ProjectMotorboat.CollectionGenericObjects;


public class HarborService : AbstractCompany
{
    public HarborService(int picWidth, int picHeight, ICollectionGenericObjects<DrawningBoat> collection) : base(picWidth, picHeight, collection)
    {
    }

    protected override void DrawBackgound(Graphics g)
    {
        int width = _pictureWidth / _placeSizeWidth;
        int height = _pictureHeight / _placeSizeHeight;
        Pen pen = new(Color.Black, 2);
        for (int i = 0; i < width; i++)
        {
            for (int j = 0; j < height + 1; ++j)
            {
                g.DrawLine(pen, i * _placeSizeWidth + 5, j * _placeSizeHeight, i * _placeSizeWidth + 5 + _placeSizeWidth - 45, j * _placeSizeHeight);
                g.DrawLine(pen, i * _placeSizeWidth + 5, j * _placeSizeHeight, i * _placeSizeWidth + 5, j * _placeSizeHeight - _placeSizeHeight);
            }
        }
    }

    protected override void SetObjectsPosition()
    {

        int width = _pictureWidth / _placeSizeWidth;
        int height = _pictureHeight / _placeSizeHeight;

        int boatWidth = 0;
        int boatHeight = 0;

        for (int i = 0; i < (_collection?.Count ?? 0); i++)
        {
           try
            {
                _collection.Get(i).SetPictureSize(_pictureWidth, _pictureHeight);
                _collection.Get(i).SetPosition(_placeSizeWidth * boatWidth + 20, boatHeight * _placeSizeHeight + 20);
            }
            catch (ObjectNotFoundException) { }
            catch (PositionOutOfCollectionException e) { }
            if (boatWidth < width - 1)
                boatWidth++;
            else
            {
                boatWidth = 0;
                boatHeight++;
            }
            if (boatHeight > height)
            {
                return;
            }
        }
    }
}